
# tested on i586 redhat 9 machine
# tested on Fedora Core 2 (Test 1) development, as of March 18, 2004

%define _libexecdir %{prefix}/lib
%define cgibindir /var/www/cgi-bin/%{name}
%define icondir /var/www/icons

Summary: C source code browser
Name: cscope
Version: 15.5
Release: 1.1AX
Copyright: BSD
Group: Development/Tools
Source0: http://download.sourceforge.net/cscope/cscope-%{version}.tar.gz
URL: http://cscope.sourceforge.net
Buildroot: %{_tmppath}/%{name}-%{version}
Prefix: %{_prefix}
Requires: perl
Requires: perl-cgilib >= 2.18-2
Requires: kernel-source
Requires: httpd
BuildRequires: gcc

%description
cscope is an interactive, screen-oriented tool that allows the user to
browse through C source files for specified elements of code.

This rpm will install cscope, install webcscope, create the cscope database in
%{_libexecdir}/%{name},
and configure webcscope to present the latest installed kernel source code.
Once installed, type
http://localhost/cgi-bin/cscope/cscope
to view the kernel source.

The uninstall script (rpm -e cscope) does not remove any installed csope
database information.

This rpm not intended for automated installation.

%prep
%setup -q -n %{name}-%{version}

%build
%configure
make

# webcscope stuff (hilite)
(cd contrib/webcscope; gcc -o hilite hilite.c)

%install
%makeinstall
# webcscope stuff
mkdir -p %{buildroot}%{_libexecdir}/%{name}
mkdir -p %{buildroot}%{cgibindir}
cp contrib/webcscope/cscope %{buildroot}%{cgibindir}
#cp contrib/webcscope/cgi-lib.pl %{buildroot}%{cgibindir}
cp contrib/webcscope/hilite %{buildroot}%{cgibindir}

# adjust binary dir
sed -i 's@/usr/global/bin/cscope@%{_bindir}/%{name}@g' %{buildroot}%{cgibindir}/%{name}
# adjust database location
sed -i 's@/usr/local/cscope@%{_libexecdir}/%{name}@g' %{buildroot}%{cgibindir}/%{name}
# adjust hilite binary location
sed -i 's@/usr/local/cgi-bin/cscope/hilite@%{cgibindir}/hilite@g' %{buildroot}%{cgibindir}/%{name}
# adjust trivials location
sed -i 's@/usr/local/htdocs/cscope/trivials@%{_libexecdir}/%{name}/trivials@g' %{buildroot}%{cgibindir}/%{name}
# copy images
mkdir -p %{buildroot}%{icondir}
cp -dpR contrib/webcscope/icons/* %{buildroot}%{icondir}

# adjust perl location
sed -i 's@/bin/perl@/usr/bin/perl@g' %{buildroot}%{cgibindir}/%{name}

%post
# set up kernel
KERS=`ls -d /usr/src/linux*`
for I in $KERS; do
	LNX=$I
	done

%define kdbdir %{_libexecdir}/%{name}/linux
mkdir -p %{kdbdir}
cd %{kdbdir}
find  $LNX \
-path "${LNX}/arch/*" ! -path "${LNX}/arch/i386*" -prune -o \
-path "${LNX}/include/asm-*" ! -path "${LNX}/include/asm-i386*" -prune -o \
-path "${LNX}/tmp*" -prune -o \
-path "${LNX}/Documentation*" -prune -o \
-path "${LNX}/scripts*" -prune -o \
-path "${LNX}/drivers*" -prune -o \
        -name "*.[chxsS]" -print > cscope.files
# dangerous? just installed it!
%{_bindir}/%{name} -b -q -k
cd $LNX
for i in %{kdbdir}/cscope.*; do ln -s $i .; done
# build database cross reference?
%{_bindir}/%{name} -b > /dev/null 2>&1
exit 0

%postun
exit 0

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,755)
%doc TODO COPYING ChangeLog
%{_bindir}/%{name}
%{_bindir}/ocs
%{_mandir}/man1/%{name}.1*
%dir %{cgibindir}
%dir %{_libexecdir}/%{name}
%{cgibindir}/*
%{icondir}/*

%changelog
* Fri May 13 2004 Shiro Yamada
- rebuild for Asianux
